//----------------------------------------------------------------------//
// NyanFi																//
//  fBNg/ X^bN											//
//----------------------------------------------------------------------//
#ifndef HistDlgH
#define HistDlgH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ActnList.hpp>
#include "usr_scrpanel.h"

//---------------------------------------------------------------------------
class TDirHistoryDlg : public TForm
{
__published:	// IDE ŊǗR|[lg
	TAction *AddDirsAction;
	TAction *ClearAllAction;
	TActionList *ActionList1;
	TButton *HiddenCanBtn;
	TListBox *DirHistListBox;
	TMenuItem *AddDirsItem;
	TMenuItem *ClearAllItem;
	TMenuItem *Sep_1;
	TPanel *HdrPanel;
	TPanel *ListPanel;
	TPopupMenu *HistPopupMenu;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall DirHistListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State);
	void __fastcall DirHistListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall DirHistListBoxKeyPress(TObject *Sender, System::WideChar &Key);
	void __fastcall DirHistListBoxDblClick(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall ClearAllActionExecute(TObject *Sender);
	void __fastcall ClearAllActionUpdate(TObject *Sender);
	void __fastcall DirHistListBoxData(TWinControl *Control, int Index, UnicodeString &Data);
	void __fastcall AddDirsActionExecute(TObject *Sender);
	void __fastcall AddDirsActionUpdate(TObject *Sender);


private:	// [U[錾
	UnicodeString IncSeaWord;
	bool IsMigemo;

	TStringList *ListBuff;

	void __fastcall UpdateListBox(int idx = 0);

public:		// [U[錾
	UsrScrollPanel *ListScrPanel;	//VvXN[o[

	bool IsDirStack;
	bool IsAllDirHist;
	bool IsFindDirHist;

	int  RefListTag;
	UnicodeString WorkListName;

	__fastcall TDirHistoryDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TDirHistoryDlg *DirHistoryDlg;
//---------------------------------------------------------------------------
#endif
